build_helper 30.7 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34
#/*
# * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
# * contributor license agreements.  See the NOTICE file distributed with
# * this work for additional information regarding copyright ownership.
# * The OpenAirInterface Software Alliance licenses this file to You under
# * the OAI Public License, Version 1.1  (the "License"); you may not use this file
# * except in compliance with the License.
# * You may obtain a copy of the License at
# *
# *      http://www.openairinterface.org/?page_id=698
# *
# * Unless required by applicable law or agreed to in writing, software
# * distributed under the License is distributed on an "AS IS" BASIS,
# * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# * See the License for the specific language governing permissions and
# * limitations under the License.
# *-------------------------------------------------------------------------------
# * For more information about the OpenAirInterface (OAI) Software Alliance:
# *      contact@openairinterface.org
# */

# file build_helper
# brief
# authors Laurent Thomas, Lionel GAUTHIER
#
#######################################
if [ ! -f /etc/os-release ]; then
  echo "No /etc/os-release file found. You're likely on an unsupported distro."
  exit -1
fi
OS_DISTRO=$(grep "^ID=" /etc/os-release | sed "s/ID=//" | sed "s/\"//g")
OS_RELEASE=$(grep "^VERSION_ID=" /etc/os-release | sed "s/VERSION_ID=//" | sed "s/\"//g")
case "$OS_DISTRO" in
  fedora) OS_BASEDISTRO="fedora"; INSTALLER="dnf"; CMAKE="cmake" ;;
35 36
  rhel)   OS_BASEDISTRO="fedora"; INSTALLER="yum --skip-broken"; CMAKE="cmake3" ;;
  centos) OS_BASEDISTRO="fedora"; INSTALLER="yum --skip-broken"; CMAKE="cmake3" ;;
37 38 39 40 41 42
  debian) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
  ubuntu) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
esac
KERNEL_VERSION=$(uname -r | cut -d '.' -f1)
KERNEL_MAJOR=$(uname -r | cut -d '.' -f2)

43
#check if we run inside a container
44
IS_CONTAINER=`egrep -c "docker|podman|kubepods|libpod|buildah" /proc/self/cgroup || true`
45 46
#sudo is not needed when we are root
if [ "$UID" = 0 ]
47 48
then
  SUDO=''
49 50
else
  SUDO='sudo -S -E'
51
fi
52 53 54 55 56 57 58 59 60 61 62 63 64 65 66

###############################
## echo and  family
###############################
black='\E[30m'
red='\E[31m'
green='\E[32m'
yellow='\E[33m'
blue='\E[1;34m'
magenta='\E[35m'
cyan='\E[36m'
white='\E[37m'
reset_color='\E[00m'
COLORIZE=1

67
cecho()  {
68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105
    # Color-echo
    # arg1 = message
    # arg2 = color
    local default_msg="No Message."
    message=${1:-$default_msg}
    color=${2:-$green}
    [ "$COLORIZE" = "1" ] && message="$color$message$reset_color"
    echo -e "$message"
    return
}

echo_error()   { cecho "$*" $red          ;}
echo_fatal()   { cecho "$*" $red; exit -1 ;}
echo_warning() { cecho "$*" $yellow       ;}
echo_success() { cecho "$*" $green        ;}
echo_info()    { cecho "$*" $blue         ;}

########################
# distribution helpers #
########################

# This function return a string to identify the distribution we are running
# If we can't check the distribution, it returns "Unknown"
# This function return always true as exit code by design
# Examples:
#   ubuntu16.04
#   debian8.5
get_distribution_release() {
    if [[ ! -z "$OS_DISTRO$OS_RELEASE" ]]; then
        echo "$OS_DISTRO$OS_RELEASE"
    else
        echo Unknown
    fi
}

check_supported_distribution() {
    local distribution=$(get_distribution_release)
    case "$distribution" in
Robert Schmidt's avatar
Robert Schmidt committed
106
        "ubuntu22.04") return 0 ;;
107 108
        "ubuntu21.04") return 0 ;;
        "ubuntu20.04") return 0 ;;
109
        "ubuntu18.04") return 0 ;;
110
        "ubuntu16.04") return 0 ;;
111
        "fedora35")    return 0 ;;
112
        "fedora36")    return 0 ;;
113
        "rhel7")       return 0 ;;
cig's avatar
cig committed
114
        "rhel7.6")     return 0 ;;
115
        "rhel7.7")     return 0 ;;
116
        "rhel7.8")     return 0 ;;
Eurecom's avatar
Eurecom committed
117
        "rhel7.9")     return 0 ;;
118
        "rhel8.2")     return 0 ;;
119 120
        "rhel8.3")     return 0 ;;
        "rhel8.4")     return 0 ;;
121 122 123
        "rhel8.5")     return 0 ;;
        "rhel8.6")     return 0 ;;
        "rhel8.7")     return 0 ;;
Eurecom's avatar
Eurecom committed
124
        "rhel9.0")     return 0 ;;
125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169
        "centos7")     return 0 ;;
    esac
    return 1
}

##################
# Error handlers #
##################

handler_EXIT() {
	local exit_code=$?
    [ "$exit_code" -eq 0 ] || echo_error "build have failed"
	exit $exit_code
}

trap handler_EXIT EXIT

###########################
# Cleaners
###########################

clean_kernel() {
    $SUDO modprobe ip_tables
    $SUDO modprobe x_tables
    $SUDO iptables -P INPUT ACCEPT
    $SUDO iptables -F INPUT
    $SUDO iptables -P OUTPUT ACCEPT
    $SUDO iptables -F OUTPUT
    $SUDO iptables -P FORWARD ACCEPT
    $SUDO iptables -F FORWARD
    $SUDO iptables -t nat -F
    $SUDO iptables -t mangle -F
    $SUDO iptables -t filter -F
    $SUDO iptables -t raw -F
    echo_info "Flushed iptables"
    $SUDO rmmod nasmesh > /dev/null 2>&1
    $SUDO rmmod oai_nw_drv  > /dev/null 2>&1
    $SUDO rmmod openair_rf > /dev/null 2>&1
    $SUDO rmmod ue_ip > /dev/null 2>&1
    echo_info "removed drivers from kernel"
}

clean_all_files() {
 set_openair_env
 dir=$OPENAIR_DIR/cmake_targets
170
 rm -rf $dir/log $OPENAIR_DIR/targets/bin/*
laurent's avatar
laurent committed
171 172
 rm -rf $dir/ran_build $dir/ran_build_noLOG
 rm -rf $dir/lte-simulators/build 
173
 rm -rf $dir/nas_sim_tools/build 
174
 rm -rf $dir/oaisim_build_oai/build $dir/oaisim_build_oai/CMakeLists.txt
175
 rm -rf $dir/autotests/bin $dir/autotests/log $dir/autotests/*/build
176 177 178 179 180 181 182 183 184 185 186 187 188 189
}

###################################
# Compilers
###################################

#check_warnings:
#    print error message if the compilation had warnings
#argument:
#    $1: log file
check_warnings() {
  #we look for 'warning:' in the compilation log file
  #this is how gcc starts a warning
  #this is not perfect, we may get false positive
190
  warning_count=`grep "warning:" "$1" | egrep -v "jobserver unavailable|disabling jobserver mode" | wc -l`
191 192 193 194 195
  if [ $warning_count -gt 0 ]; then
    echo_error "WARNING: $warning_count warnings. See $1"
  fi
}

196 197 198 199 200
#check_errors:
#    print error message if the compilation had errors
#argument:
#    $1: log file
check_errors() {
201 202
  #we look for 'error:' in the compilation log file
  error_count=`grep -c "error:" "$1"`
203 204 205 206 207
  if [ $error_count -gt 0 ]; then
    echo_error "ERROR: $error_count error. See $1"
  fi
}

208 209
compilations() {
  cd $OPENAIR_DIR/cmake_targets/$1/build
210
  echo_info "Log file for compilation is being written to: $dlog/$2.$REL.txt"
211 212
  set +e
  {
213 214 215 216 217
    if [ "$BUILD_COVERITY_SCAN" == "1" ]; then
        COV_SCAN_PREFIX="cov-build --dir cov-int"
    else
        COV_SCAN_PREFIX=""
    fi
laurent's avatar
laurent committed
218 219 220
    if [ "$MAKE_CMD" != "" ]; then
       $MAKE_CMD $2
    else 
221
    if [ "$VERBOSE_COMPILE" == "1" ]; then
222
       $COV_SCAN_PREFIX make -j`nproc` $2 VERBOSE=$VERBOSE_COMPILE
223
    else
224
       $COV_SCAN_PREFIX make -j`nproc` $2
225
    fi
laurent's avatar
laurent committed
226
    fi
227
    ret=$?
228 229
  } > $dlog/$2.$REL.txt 2>&1
  set -e
230 231 232 233 234
  if [ "$VERBOSE_CI" == "1" ]; then
     echo_info "====== Start of log for $2.$REL.txt ======"
     cat $dlog/$2.$REL.txt
     echo_info "====== End of log for $2.$REL.txt ======"
  fi
235 236 237 238 239 240
  if [[ $ret -ne 0 ]]; then
     check_warnings "$dlog/$2.$REL.txt"
     check_errors "$dlog/$2.$REL.txt"
     echo_error "$2 compilation failed"
     exit 1
  fi
laurent's avatar
laurent committed
241 242 243
  if [ -s "$3" ] ; then
     rm -f "$4"
     ln -s "$PWD/$3" "$4"
244 245 246
     echo_success "$2 compiled"
     check_warnings "$dlog/$2.$REL.txt"
  else
247 248
     check_warnings "$dlog/$2.$REL.txt"
     check_errors "$dlog/$2.$REL.txt"
249 250 251 252 253 254 255 256 257
     echo_error "$2 compilation failed"
     exit 1
  fi
}

############################################
# External packages installers
############################################

258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294
install_protobuf_from_source(){
    protobuf_install_log=$OPENAIR_DIR/cmake_targets/log/protobuf_install_log.txt
    echo_info "\nInstalling Google Protobuf from sources. The log file for Protobuf installation is here: $protobuf_install_log "
    (
    cd /tmp
    echo "Downloading protobuf"
    #rm -rf /tmp/protobuf-2.6.1.tar.gz* /tmp/protobuf-2.6.1
    #wget https://github.com/protocolbuffers/protobuf/releases/download/v2.6.1/protobuf-2.6.1.tar.gz
    #tar -xzvf protobuf-2.6.1.tar.gz --owner $USER --group $USER --no-same-owner
    #cd protobuf-2.6.1/

    if [ $IS_CONTAINER -eq 0 ]
    then
      rm -rf /tmp/protobuf-cpp-3.3.0.tar.gz* /tmp/protobuf-3.3.0
      wget --tries=3 --retry-connrefused https://github.com/protocolbuffers/protobuf/releases/download/v3.3.0/protobuf-cpp-3.3.0.tar.gz
      tar -xzvf protobuf-cpp-3.3.0.tar.gz --owner $(id -u) --group $(id -g) --no-same-owner
      cd protobuf-3.3.0/
    else
      export LD_LIBRARY_PATH=/usr/local/lib #protoc needs to know where toclook for shared libs
      rm -rf /tmp/protobuf
      git clone --depth=1 --branch=v3.3.0 https://github.com/protocolbuffers/protobuf.git /tmp/protobuf
      cd /tmp/protobuf
      git submodule update --init --recursive
      ./autogen.sh
    fi
    ./configure
    echo "Compiling protobuf"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    if [[ -v CI_ENV ]]; then
        cd /tmp
        $SUDO rm -rf protobuf*
    fi
    ) >& $protobuf_install_log
}

295 296 297
install_protobuf_c_from_source(){
    protobuf_c_install_log=$OPENAIR_DIR/cmake_targets/log/protobuf_c_install_log.txt
    echo_info "\nInstalling Google Protobuf_C from sources. The log file for Protobuf_C installation is here: $protobuf_c_install_log "
298
    (
299 300 301 302 303 304 305 306 307 308 309 310 311 312 313
    if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
        export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig
    fi
    cd /tmp
    echo "Downloading protobuf-c"
    rm -rf /tmp/protobuf-c
    git clone https://github.com/protobuf-c/protobuf-c.git
    cd protobuf-c
	git checkout 2a46af42784abf86804d536f6e0122d47cfeea45
    ./autogen.sh
    ./configure
    echo "Compiling protobuf-c"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
314 315 316 317
    if [[ -v CI_ENV ]]; then
        cd /tmp
        $SUDO rm -rf protobuf*
    fi
318
    ) >& $protobuf_c_install_log
319 320
}

321 322 323
install_protobuf_c() {
  local protobuf_packages=""
  case "$(get_distribution_release)" in
Robert Schmidt's avatar
Robert Schmidt committed
324
    "ubuntu18.04" | "ubuntu20.04" | "ubuntu21.04" | "ubuntu22.04")
325 326 327
      protobuf_packages="protobuf-c-compiler libprotobuf-c1 libprotobuf-c-dev"
      ;;
  esac
328 329 330 331 332
  case "$OS_DISTRO" in
    "rhel" | "centos" | "fedora") # in EPEL and Fedora repos (at least as of 35)
      protobuf_packages="protobuf-c-compiler protobuf-c protobuf-c-devel"
      ;;
  esac
333
  if [[ "$protobuf_packages" == "" ]]; then
334
    install_protobuf_from_source
335 336 337 338 339 340
    install_protobuf_c_from_source
  else
    $SUDO $INSTALLER -y install $protobuf_packages
  fi
}

341 342 343 344
install_usrp_uhd_driver_from_source(){
    uhd_install_log=$OPENAIR_DIR/cmake_targets/log/uhd_install_log.txt
    echo_info "\nInstalling UHD driver from sources. The log file for UHD driver installation is here: $uhd_install_log "
    (
Raphael Defosseux's avatar
Raphael Defosseux committed
345
    pushd /tmp
346
    echo "Cloning UHD driver repository"
347 348 349
    rm -rf /tmp/uhd
    git clone https://github.com/EttusResearch/uhd.git
    cd uhd
350 351
    # For our legacy TDD eNB running with a B2xx RF board
    # the following patch has to be applied
352 353
    if [[ -v UHD_VERSION ]]; then
        git checkout tags/v${UHD_VERSION}
354 355 356 357 358
        # We recommend to use not older than 3.15.0.0
        if [[ "$UHD_VERSION" == "3.15.0.0" ]]; then
            # Tested that patch for the following versions:
            # - 3.15.0.0
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-3.15-tdd-patch.diff
359
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
360 361 362 363 364 365 366 367 368
        else
            # Tested that patch for the following versions:
            # - 4.0.0.0
            # - 4.1.0.0
            # - 4.1.0.5
            # - 4.2.0.0
            # - 4.2.0.1
            # - 4.3.0.0-rc1
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
369
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
370
        fi
371 372
    else
        git checkout tags/v4.0.0.0
373
        git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
374
        ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
375
    fi
376 377
    # Printing out the results of the patch to make sure it was properly applied
    git diff
378
    mkdir -p host/build
379 380
    cd host/build || true
    $CMAKE ../ -GNinja
381
    echo "Compiling UHD"
382 383
    ninja
    $SUDO ninja install
Raphael Defosseux's avatar
Raphael Defosseux committed
384
    $SUDO ldconfig -v
385 386 387 388 389 390 391 392
    if [ $IS_CONTAINER -eq 0 ]; then
        if [[ "$OS_DISTRO" == "ubuntu" ]]; then
            $SUDO /usr/local/lib/uhd/utils/uhd_images_downloader.py
        fi
        if [[ "$OS_DISTRO" == "rhel" ]]; then
            $SUDO /usr/local/lib64/uhd/utils/uhd_images_downloader.py
        fi
    fi
Raphael Defosseux's avatar
Raphael Defosseux committed
393 394
    popd
    rm -rf /tmp/uhd
395 396 397 398 399 400
    ) >& $uhd_install_log
}

check_install_usrp_uhd_driver(){
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        #first we remove old installation
401 402 403 404 405 406 407 408 409
        $SUDO apt-get remove uhd -y || true
        $SUDO apt-get remove uhd-host -y || true
        $SUDO apt-get remove libuhd-dev -y || true
        $SUDO apt-get remove libuhd003 -y || true
        $SUDO apt-get remove libuhd3.13.1 -y || true
        $SUDO apt-get remove libuhd3.14.0 -y || true
        $SUDO apt-get remove libuhd3.14.1 -y || true
        $SUDO apt-get remove libuhd3.15.0 -y || true
        local distribution=$(get_distribution_release)
410
        if [[ "$distribution" == "ubuntu18.04" || "$distribution" == "ubuntu20.04" || "$distribution" == "ubuntu22.04" ]]; then
411 412 413
            $SUDO apt-get remove libuhd4.0.0 -y || true
            $SUDO apt-get remove libuhd4.1.0 -y || true
        fi
414 415
        v=$(lsb_release -cs)
        $SUDO apt-add-repository --remove "deb http://files.ettus.com/binaries/uhd/repo/uhd/ubuntu/$v $v main"
416 417 418 419 420
        if [[ -v BUILD_UHD_FROM_SOURCE ]]; then
            $SUDO apt-get install -y libboost-all-dev libusb-1.0-0-dev doxygen python3-docutils python3-mako python3-numpy python3-requests python3-setuptools ninja-build
            install_usrp_uhd_driver_from_source
            return
        fi
421
        # The new USRP repository
422
        # Raphael Defosseux: Adding a loop on adding PPA because in CI the gpg key retrieve may
423 424 425 426 427 428 429 430 431 432 433 434 435 436 437
        # timeout due to proxy / network latencies in Eurecom on VM
        echo_info "\nAdding PPA repository ettusresearch/uhd\n"
        x=0
        while [ $x -le 5 ]
        do
            if $SUDO add-apt-repository ppa:ettusresearch/uhd -y
            then
                echo_info "add-apt-repository successful\n"
                break
            else
                echo_info "add-apt-repository failed, retrying...\n"
                sleep 30
            fi
            x=$((x + 1))
        done
438
        $SUDO apt-get update
439
        $SUDO apt-get -y install python-tk libboost-all-dev libusb-1.0-0-dev
440 441
        case "$(get_distribution_release)" in
          "ubuntu16.04")
442
            $SUDO apt-get -y install libuhd-dev libuhd3.15.0 uhd-host
443 444 445 446 447
            ;;
          "ubuntu18.04" | "ubuntu20.04" | "ubuntu22.04")
            $SUDO apt-get -y install libuhd-dev libuhd4.2.0 uhd-host
            ;;
        esac
448
    elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
Raphael Defosseux's avatar
Raphael Defosseux committed
449 450
        if [ $IS_CONTAINER -eq 0 ]
        then
451
            $SUDO $INSTALLER -y install python boost libusb-devel libusbx-devel boost-devel python-mako python-docutils $CMAKE
Raphael Defosseux's avatar
Raphael Defosseux committed
452 453
            $SUDO -H pip install requests
        else
454
            $SUDO $INSTALLER -y install boost boost-devel $CMAKE
Raphael Defosseux's avatar
Raphael Defosseux committed
455 456
            $SUDO pip3 install mako requests
        fi
457
        if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
Raphael Defosseux's avatar
Raphael Defosseux committed
458 459 460 461 462
            if [ $IS_CONTAINER -eq 0 ]
            then
                # until EPEL repo hasn't bumped UHD driver to >=3.10 in EPEL, build driver from source
                $SUDO $INSTALLER -y remove uhd uhd-devel uhd-firmware
            fi
463 464 465 466 467 468 469 470 471 472 473 474 475
            install_usrp_uhd_driver_from_source
        else
            $SUDO $INSTALLER -y install uhd uhd-devel uhd-firmware
        fi
    fi
}

install_usrp_uhd_driver() {
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        # We move uhd-host apart because it depends on linux kernel version
        # On newer kernels, it fails to install
        $SUDO apt-get -y install uhd-host
    fi
476 477
    # quick workaround for RHE7.6
    local distribution=$(get_distribution_release)
478
    if [ -z $1 ]; then
479
      if [[ "$OS_DISTRO" == "rhel" ]]; then
480 481 482 483
          $SUDO /usr/local/bin/uhd_images_downloader
      else
          $SUDO uhd_images_downloader
      fi
484
    else
485
      if [[ "$OS_DISTRO" == "rhel" ]]; then
486 487 488 489
          $SUDO /usr/local/bin/uhd_images_downloader -i $1
      else
          $SUDO uhd_images_downloader -i $1
      fi
490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511
    fi
}

install_bladerf_driver_from_source(){
    bladerf_install_log=$OPENAIR_DIR/cmake_targets/log/bladerf_install_log.txt
    echo_info "\nInstalling BladeRF driver from sources. The log file for BladeRF driver installation is here: $bladerf_install_log "
    (
    cd /tmp
    echo "Downloading BladeRF driver"
    rm -rf /tmp/bladeRF
    git clone https://github.com/Nuand/bladeRF.git
    cd bladeRF
    git checkout tags/2016.06
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling BladeRF driver"
    make
    $SUDO make install
    $SUDO ldconfig
    echo "Downloading FPGA and firmware images"
    cd /tmp/bladeRF
512 513
    wget --tries=3 --retry-connrefused https://www.nuand.com/fx3/bladeRF_fw_latest.img
    wget --tries=3 --retry-connrefused https://www.nuand.com/fpga/hostedx40-latest.rbf
514 515 516 517 518 519 520 521
    sudo mkdir -p /usr/share/Nuand/bladeRF
    sudo mv bladeRF_fw_latest.img /usr/share/Nuand/bladeRF/bladeRF_fw.img
    sudo mv hostedx40-latest.rbf /usr/share/Nuand/bladeRF/hostedx40.rbf
    ) >& $bladerf_install_log
}

check_install_bladerf_driver(){
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
522 523 524
        $SUDO apt-get install -y  bladerf libbladerf-dev
        $SUDO apt-get install -y bladerf-firmware-fx3
        $SUDO apt-get install -y bladerf-fpga-hostedx40
525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543
   elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
        install_bladerf_driver_from_source
   else
        echo_error "BladeRF Installer for OAI does not support automatic build. Install BladeRF compiling sources manually from BladeRF website"
   fi
}

flash_firmware_bladerf() {
	$SUDO bladeRF-cli --flash-firmware /usr/share/Nuand/bladeRF/bladeRF_fw.img
}

check_install_lmssdr_driver(){
	if ( [ -d "/usr/local/include/lime" ] &&
             [ -f "/usr/local/include/lime/LimeSuite.h" ] )
	then
  		echo_success "Found lmssdr drivers and tools installed from source"
        else
                echo_error "lmssdr support implies installing lmssdr drivers and tools" \
                           " from sources. check:"
Laurent's avatar
Laurent committed
544
                echo_info "https://wiki.myriadrf.org/Lime_Suite"
545
                echo_fatal "Cannot compile lmssdr device"
546 547 548 549 550
	fi


}

551 552 553 554 555 556 557
install_soapy_from_source(){
    soapy_install_log=$OPENAIR_DIR/cmake_targets/log/soapy_install_log.txt
    echo_info "\nInstalling Soapy EcoSystem from source. The log file for Soapy installation is here: $soapy_install_log "
    (
    cd /tmp
    echo "Downloading SoapySDR"
    rm -rf /tmp/soapysdr
Rahman Doost's avatar
Rahman Doost committed
558 559
    git clone -b soapy-sdr-0.7.0 --single-branch https://github.com/pothosware/SoapySDR.git
    cd SoapySDR
560 561 562 563 564 565 566 567 568 569 570
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling SoapySDR"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    cd /tmp
    echo "Downloading SoapyRemote"
    rm -rf /tmp/soapyremote
Rahman Doost's avatar
Rahman Doost committed
571 572
    git clone -b soapy-remote-0.5.0 --single-branch https://github.com/pothosware/SoapyRemote.git
    cd SoapyRemote
573 574 575
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
576
    $CMAKE ../
577 578 579 580 581 582 583 584 585 586 587 588 589 590
    echo "Compiling SoapyRemote"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $soapy_install_log
}

install_soapy_iris_from_source(){
    iris_install_log=$OPENAIR_DIR/cmake_targets/log/iris_install_log.txt
    echo_info "\nInstalling Iris driver from source. The log file for Iris driver installation is here: $iris_install_log "
    (
    cd /tmp
    echo "Downloading SoapyIris"
    rm -rf /tmp/sklk-soapyiris
Rahman Doost's avatar
Rahman Doost committed
591
    git clone -b soapy-iris-2018.08.0.1 --single-branch https://github.com/skylarkwireless/sklk-soapyiris.git
592 593 594
    cd sklk-soapyiris
    mkdir -p build
    cd build
595
    $CMAKE ../
596 597 598 599 600 601 602 603 604 605
    echo "Compiling SoapyIris"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $iris_install_log
}

check_install_soapy () {
    #if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        #first we remove old installation
Rahman Doost's avatar
Rahman Doost committed
606 607 608 609
    $SUDO apt-get remove -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote || true
        #$SUDO add-apt-repository -y ppa:myriadrf/drivers
        #$SUDO apt-get update
        #$SUDO apt-get install -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote
610 611 612

    #elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
    #    $SUDO $INSTALLER -y install software-properties-common python3-software-properties python-software-properties subversion git python3 python-numpy python3-numpy cmake swig python-dev
Rahman Doost's avatar
Rahman Doost committed
613
    install_soapy_from_source
614 615 616 617 618
    #fi
    install_soapy_iris_from_source

}

619 620
check_install_additional_tools (){
  $SUDO $INSTALLER update -y
621
  local optional_packages=""
622
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
623
    case "$(get_distribution_release)" in
624
        "ubuntu16.04"| "ubuntu18.04")
Robert Schmidt's avatar
Robert Schmidt committed
625
            optional_packages="python-dev python-pexpect python-numpy python-scipy python-matplotlib ctags"
626
            ;;
Robert Schmidt's avatar
Robert Schmidt committed
627 628
        "ubuntu20.04" | "ubuntu21.04" | "ubuntu22.04" )
            optional_packages="python3 python3-pip python3-dev python3-scipy python3-matplotlib universal-ctags"
629 630
            ;;
    esac
631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652
    PACKAGE_LIST="\
	check \
	dialog \
	dkms \
	gawk \
	libboost-all-dev \
	libpthread-stubs0-dev \
	openvpn \
	pkg-config \
	sshfs \
	swig  \
	tshark \
	uml-utilities \
	unzip  \
	valgrind  \
	vlan	  \
        ntpdate \
        iperf3 \
        android-tools-adb \
	wvdial \
        sshpass \
        bc \
653
        ntp"
654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697
  elif [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
    PACKAGE_LIST="\
      check \
      dialog \
      dkms \
      gawk \
      boost-devel \
      openvpn \
      pkgconfig \
      pexpect \
      sshfs \
      swig  \
      wireshark \
      unzip  \
      valgrind  \
      vconfig	  \
      ctags \
      ntpdate \
      iperf3 \
      wvdial \
      numpy \
      sshpass \
      python2-paramiko \
      python-pyroute2 \
      python-netifaces \
      scipy \
      python-matplotlib"
  elif [[ "$OS_DISTRO" == "fedora" ]]; then
    PACKAGE_LIST=" \
      check \
      dialog \
      dkms \
      gawk \
      boost-devel \
      openvpn \
      pkgconfig \
      python-pexpect \
      sshfs \
      swig  \
      wireshark \
      unzip  \
      valgrind  \
      vconfig	  \
      ctags \
698
      ntpsec \
699 700 701 702
      iperf3 \
      wvdial \
      python-numpy \
      sshpass \
703
      python-paramiko \
704 705
      python-pyroute2 \
      python-netifaces \
706 707
      python-scipy \
      python-matplotlib"
708
  fi
709
    $SUDO $INSTALLER install -y $PACKAGE_LIST $optional_packages
710

711 712
  #The packages below are already installed for Redhat distros (RHEL, CentOS, Fedora)
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
713 714
    $SUDO -H pip install paramiko
    $SUDO -H pip install pyroute2 colorama
715 716 717 718
    log_netiface=$OPENAIR_DIR/cmake_targets/log/netiface_install_log.txt
    echo_info "Installing Netinterfaces package. The logfile for installation is in $log_netiface"
    (
    $SUDO rm -fr /tmp/netifaces-0.10.4.tar.gz /tmp/netifaces
719
    wget --tries=3 --retry-connrefused -P /tmp  https://pypi.python.org/packages/18/fa/dd13d4910aea339c0bb87d2b3838d8fd923c11869b1f6e741dbd0ff3bc00/netifaces-0.10.4.tar.gz
720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740
    tar -xzvf /tmp/netifaces-0.10.4.tar.gz -C /tmp
    cd /tmp/netifaces-0.10.4
    $SUDO python setup.py install
    cd -
    ) >& $log_netiface
  fi
}

check_install_oai_software() {
    local specific_packages=""
    if ! check_supported_distribution; then
        echo_error "Your distribution $(get_distribution_release) is not supported by oai !"
        exit 1
    fi
    $SUDO $INSTALLER update -y
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
    local LAPACK_LIBNAME="liblapack.so"
    local LAPACK_TARGET="/usr/lib/atlas-base/atlas/liblapack.so"
    $SUDO apt install -y software-properties-common
    case "$(get_distribution_release)" in
        "ubuntu16.04")
Robert Schmidt's avatar
Robert Schmidt committed
741
            specific_packages="libtasn1-6-dev libgnutls-dev libatlas-dev iproute libconfig8-dev iptables-dev libgcrypt11-dev python-pip pydb python guile-2.0-dev"
742
            ;;
743
        "ubuntu18.04")
Robert Schmidt's avatar
Robert Schmidt committed
744
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev iptables-dev libgcrypt11-dev python-pip pydb python guile-2.0-dev"
745 746 747 748
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
        "ubuntu20.04")
Robert Schmidt's avatar
Robert Schmidt committed
749
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python guile-2.0-dev"
750 751 752 753
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
         "ubuntu21.04")
Robert Schmidt's avatar
Robert Schmidt committed
754 755 756 757 758 759
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python guile-2.0-dev"
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
         "ubuntu22.04")
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python2 guile-2.2-dev"
760 761 762 763 764 765 766 767 768 769
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
    esac
    $SUDO apt-get install -y \
    $specific_packages \
	autoconf  \
	automake  \
	bison  \
	build-essential \
770
	$CMAKE \
771
	cmake-curses-gui  \
772
	curl \
laurent's avatar
laurent committed
773
        ninja-build \
774 775 776 777 778
	doxygen \
	doxygen-gui \
	texlive-latex-base \
	ethtool \
	flex  \
779 780
        g++ \
        gcc \
781 782 783 784 785 786 787 788
	gdb  \
	git \
	graphviz \
	gtkwave \
	iperf \
	iptables \
	libatlas-base-dev \
	libblas-dev \
789 790
	liblapack-dev \
	liblapacke-dev \
791 792 793 794 795 796 797 798 799
	libffi-dev \
	libforms-bin \
	libforms-dev \
	libgmp-dev \
	libgtk-3-dev \
	libidn2-0-dev  \
	libidn11-dev \
	libmysqlclient-dev  \
	libpython2.7-dev \
800
        libreadline-dev \
801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816
	libsctp1  \
	libsctp-dev  \
	libssl-dev  \
	libtool  \
	libusb-1.0-0-dev \
	libxml2 \
	libxml2-dev  \
	libxslt1-dev \
	octave-signal \
	openssh-client \
	openssh-server \
	openssl \
	subversion \
	xmlstarlet \
	libyaml-dev \
	wget \
817 818
	libxpm-dev \
        libboost-all-dev
819 820 821 822 823 824 825 826 827 828 829 830

    $SUDO update-alternatives --set "$LAPACK_LIBNAME" "$LAPACK_TARGET"

    $SUDO apt-get install -y nettle-dev nettle-bin
  elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
    if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
      if rpm -q epel-release > /dev/null; then
        echo "EPEL repos already present. Good."
      else
        echo "EPEL repos not present. Installing them."
        $SUDO $INSTALLER install -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm
      fi
Cedric Roux's avatar
Cedric Roux committed
831
      $SUDO $INSTALLER install -y python-epdb vim-common
832
    fi
833

834 835 836 837 838 839 840 841 842
    $SUDO $INSTALLER install -y \
      autoconf \
      automake \
      bc \
      bison \
      $CMAKE \
      doxygen \
      ethtool \
      flex \
843 844
      g++ \
      gcc \
845 846 847 848 849 850 851 852 853 854 855 856 857 858 859 860 861 862 863 864 865 866 867 868 869 870 871 872 873 874
      gdb \
      git \
      graphviz \
      gtkwave \
      guile-devel \
      iperf \
      iproute \
      iptables \
      iptables-devel \
      atlas-devel \
      blas-devel \
      libconfig-devel \
      libffi-devel \
      xforms \
      xforms-devel \
      libgcrypt-devel \
      gmp-devel \
      gtk3-devel \
      libidn2-devel  \
      libidn-devel \
      mariadb-devel \
      lksctp-tools \
      lksctp-tools-devel \
      openssl-devel \
      libtasn1 \
      libtool \
      libusb-devel \
      libxml2 \
      libxml2-devel \
      libxslt-devel \
875 876
      ninja-build \
      make \
877 878 879 880 881 882
      openssh-clients \
      openssh-server \
      openssl \
      patch \
      psmisc \
      python \
883
      readline-devel \
884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899
      subversion \
      xmlstarlet \
      python-pip \
      wget \
      kernel-headers \
      kernel-devel \
      nettle-devel \
      gnutls-devel \
      libXpm-devel \
      lapack \
      lapack-devel \
      blas \
      blas-devel \
      libyaml-devel
  fi

900
    install_asn1c_from_source $1
901 902 903 904 905 906 907
}

install_asn1c_from_source(){
    asn1_install_log=$OPENAIR_DIR/cmake_targets/log/asn1c_install_log.txt
    echo_info "\nInstalling ASN1. The log file for ASN1 installation is here: $asn1_install_log "
    (
    $SUDO rm -rf /tmp/asn1c
908
    # GIT_SSL_NO_VERIFY=true git clone https://gitlab.eurecom.fr/oai/asn1c.git /tmp/asn1c
Cedric Roux's avatar
Cedric Roux committed
909
    git clone https://gitlab.eurecom.fr/oai/asn1c.git /tmp/asn1c
910
    cd /tmp/asn1c
Cedric Roux's avatar
Cedric Roux committed
911 912 913
    # better to use a given commit than a branch in case the branch
    # is updated and requires modifications in the source of OAI
    #git checkout velichkov_s1ap_plus_option_group
914
    git checkout f12568d617dbf48497588f8e227d70388fa217c9
915
    autoreconf -iv
916 917 918 919 920
    ./configure
    make -j`nproc`
    $SUDO make install
    cd -
    $SUDO ldconfig
921 922 923
    if [[ -v CI_ENV ]]; then
        $SUDO rm -rf /tmp/asn1c
    fi
924 925 926 927
    ) > $asn1_install_log 2>&1
}

#################################################
928
# 2. compile
929 930 931
################################################

install_nas_tools() {
Laurent THOMAS's avatar
Laurent THOMAS committed
932 933 934 935
  echo_success "generate .ue_emm.nvram .ue.nvram"
  ./nvram --gen -c $1 -o $2 > "$3"
  echo_success "generate .usim.nvram"
  ./usim --gen -c $1 -o $2 >> "$3"
936 937 938 939 940 941 942 943 944 945 946
}


################################
# set_openair_env
###############################
set_openair_env(){
    fullpath=`readlink -f $BASH_SOURCE`
    [ -f "/.$fullpath" ] || fullpath=`readlink -f $PWD/$fullpath`
    openair_path=${fullpath%/cmake_targets/*}
    openair_path=${openair_path%/targets/*}
947
    openair_path=${openair_path%/openair[123]/*}
948 949 950 951 952 953 954 955 956 957 958 959 960 961 962 963
    export OPENAIR_DIR=$openair_path
    export OPENAIR1_DIR=$openair_path/openair1
    export OPENAIR2_DIR=$openair_path/openair2
    export OPENAIR3_DIR=$openair_path/openair3
    export OPENAIR_TARGETS=$openair_path/targets
}

################################
# Function to killall the subprocesses when Ctrl-C Key is hit
###############################
function handle_ctrl_c(){
CURPID=$$
ppid=$$
arraycounter=1
echo_info "** Trapped CTRL-C. Killing all subprocesses now..."
echo_info "** Calling sync now..."
964
sync
965 966 967 968 969 970 971 972 973 974 975 976 977 978 979 980 981
while true
do
        FORLOOP=FALSE
        # Get all the child process id
        for i in `ps -ef| awk '$3 == '$ppid' { print $2 }'`
        do
                if [ $i -ne $CURPID ] ; then
                        procid[$arraycounter]=$i
                        arraycounter=`expr $arraycounter + 1`
                        ppid=$i
                        FORLOOP=TRUE
                fi
        done
        if [ "$FORLOOP" = "FALSE" ] ; then
           arraycounter=`expr $arraycounter - 1`
           ## We want to kill child process id first and then parent id's
           while [ $arraycounter -ne 0 ]
982
           do
983 984 985 986 987 988 989 990 991 992 993
             echo "first we send ctrl-c to program"
             $SUDO kill -INT "${procid[$arraycounter]}"
             sleep 5
             echo "Now we force kill if that didn't work"
             $SUDO kill -9 "${procid[$arraycounter]}" >/dev/null
             arraycounter=`expr $arraycounter - 1`
           done
         exit
        fi
done
}